//
// MY_berr
//
// Description of the project
// Developed with [embedXcode](http://embedXcode.weebly.com)
//
// Author       刘钊
//              刘钊
//
// Date         15/10/29 下午2:41
// Version      <#version#>
//
// Copyright    © 刘钊, 2015年
// Licence      <#licence#>
//
// See         ReadMe.txt for references
//
#include <Arduino.h>
#include "Uart.h"
// Add setup code
/****************************************************************************
 * 名称：全局变量
 * 功能：
 * 参数：
 ****************************************************************************/
unsigned char ThData,Thtime,ZfData,Zftime;
int Relay1 = 2, Relay2 = 3, Relay3 = 4 , Relay4 = 5;

Uart myHmi;
/****************************************************************************
 * 名称：系统初始化
 * 功能：
 * 参数：
 ****************************************************************************/
void setup()
{
    delay(200); //延迟200毫秒,等待串口上电后数据稳定.
    Serial.begin(9600);
    Serial.println("PC串口初始化_成功");
    Serial1.begin(9600);
    Serial.println("UART串口初始化_成功");
    pinMode(Relay1, OUTPUT);
    pinMode(Relay2, OUTPUT);
    pinMode(Relay3, OUTPUT);
    pinMode(Relay4, OUTPUT);
    Serial.println("继电器初始_成功");
    myHmi.UartEnd();
    Serial.println("发送结束符_清理串口数据");

    
}
/****************************************************************************
 * 名称：函数声明
 * 功能：
 * 参数：E
 ****************************************************************************/
void GetData(void);
void MainProgram(void);
void MainState(void);
/****************************************************************************
 * 名称：调度程序
 * 功能：
 * 参数：EndButton=false,StartButton=false ,PauseButton=false,ContinueButton=false;
 ****************************************************************************/
void MainProgram()
{
    static int Step=0; //循环函数
    static int Ltime=0;//时间判断函数
    //结束按钮==开&&开始按钮==关&&暂停按钮==关&&继续按钮==开,当前状态关
    if (myHmi.EndButton==true&&myHmi.StartButton==false)
    {
        Step=0;
        //Serial.println("设置参数状态2");
        
    }
    if ( myHmi.StartButton==true)
    {
        Step=1;
        //Serial.println("程序执行");
        
    }
    if ( myHmi.PauseButton==true&& myHmi.StartButton==true)
    {
        Step=2;
        //Serial.println("程序暂停");
        
    }
    if ( myHmi.ContinueButton==true&& myHmi.StartButton==true)
    {
        Step=1;
        //Serial.println("程序继续");
        
    }
    switch (Step) {
        case 0:
            //delay(2000);
            //Serial.println("空闲状态");
            break;
        case 1:
            MainState();
            //Serial.println("主程序执行");
            break;
        case 2:
            Serial.println("执行暂停");
            break;
        case 3:
            Serial.println("");
            break;
        case 4:
            Serial.println("");
            break;
        default:
            break;
    }
    
}
/****************************************************************************
 * 名称：主函数
 * 功能：糖化过程,煮沸过程
 * 参数：E
 ****************************************************************************/
void MainState()
{
    static int Step=0; //选择函数
    static int Ltime=0;//时间判断函数
    if (ThData==0) //判断是否已读初始数据
    {
        Step=30;
    }
    switch (Step) {
        case 0:
            Step=1;
            Ltime=millis();
            break;
        case 1:
            if (millis() - Ltime > 100) //100ms 检测一次水量
            {
                
                Ltime = millis();
                Serial.println("下一状态");
            }
            break;
        case 2:
            break;
        case 30:
            GetData();
            Serial.println("取屏幕数据到全局变量");
            Step=0;         //返回到第一步
            break;
        default:
            break;
    }
    
}
/****************************************************************************
 * 名称：GetData()
 * 功能：取屏页面1数据;
 * 参数：ThData,Thtime,ZfData,Zftime;
 ****************************************************************************/
void GetData()
{
    
    ThData = myHmi.GetControlV(0);
    Serial.print("ThData:");
    Serial.println(ThData);
    
    Thtime=myHmi.GetControlV(1);
    Serial.print("ThTime:");
    Serial.println(Thtime);
    
    ZfData =myHmi.GetControlV(2);
    Serial.print("ZfData:");
    Serial.println(ZfData );
    
    Zftime = myHmi.GetControlV(3);
    Serial.print("ZfTime:");
    Serial.println(Zftime);
    
}
/****************************************************************************
 * 名称：继电器开关
 * 功能：打开关闭继电器
 * 参数：Relay1,2,3,4, on&&off
 ****************************************************************************/
void Relay1_ON()
{
    digitalWrite(Relay1, HIGH);
    Serial.println("Relay1_on");
}
void Relay1_OFF()
{
    digitalWrite(Relay1, LOW);
    Serial.println("Relay1_off");
}
void Relay2_ON()
{
    digitalWrite(Relay2, HIGH);
    Serial.println("Relay1_on");
}
void Relay2_OFF()
{
    digitalWrite(Relay2, LOW);
    Serial.println("Relay1_off");
}
void Relay3_ON()
{
    digitalWrite(Relay3, HIGH);
    Serial.println("Relay1_on");
}
void Relay3_OFF()
{
    digitalWrite(Relay3, LOW);
    Serial.println("Relay1_off");
}
void Relay4_ON()
{
    digitalWrite(Relay4, HIGH);
    Serial.println("Relay1_on");
}
void Relay4_OFF()
{
    digitalWrite(Relay4, LOW);
    Serial.println("Relay1_off");
}
/****************************************************************************
 * 名称：主循环
 * 功能：
 * 参数：
 ****************************************************************************/
void loop()
{
    myHmi.WaitCommand(0);//串口检测函数
    myHmi.ButtonState();//按键扫描
    MainProgram(); //主程序执行
    
}
