//
// File			Uart.h
// Header
//
// Details		<#details#>
//
// Project		 MY_berr
// Developed with [embedXcode](http://embedXcode.weebly.com)
//
// Author		刘钊
// 				刘钊
//
// Date			15/10/29 下午3:28
// Version		<#version#>
//
// Copyright	© 刘钊, 2015年
// Licence    <#license#>
//
// See			ReadMe.txt for references
//
#ifndef Uart_H  //预编译指令，防止重复定义类
#define Uart_H
#include "Arduino.h"
/****************************************************************************
 * 名称： UART_HMI 无效命令返回常量
 * 功能：
 * 参数：
 ****************************************************************************/
#define Error_CommandNO       0X00	//无效指令       0X00+结束符
#define Error_CommandOK       0X01	//指令成功执行    0X01+结束符
#define Error_ControlIdNO     0X02	//控件ID无效     0X02+结束符
#define Error_ScreenIdNO      0X03	//页面ID无效     0X03+结束符
#define Error_PicIdNO         0X04	//图片ID无效     0X04+结束符
#define Error_FondNO          0X05	//字库ID无效     0X05+结束符
#define Error_BeginNO         0X11	//波特率设置无效  0X11+结束符
#define Error_CurveIdNO       0X12	//曲线控件或通道  0X12+结束符
#define Error_VariableNO      0X1A	//变量名称无效    0X1A+结束符
#define Error_OperationNO     0X1B	//变量运算无效    0X1B+结束符
/****************************************************************************
 * 名称： UART_HMI 有效命令返回常量
 * 功能：
 * 参数：
 ****************************************************************************/
#define UART_touch          0X65    //触摸热区事件返回
#define UART_ID             0X66    //当前页面的ID号返回
#define UART_Touchdata      0X67    //触摸坐标数据返回
#define UART_Sleep          0X68    //睡眠模式触摸事件
#define UART_Ascii          0X70    //字符串变量数据返回
#define UART_Datavar        0X71    //数值变量数据返回
#define UART_Sleepmode      0x86    //设备自动进入睡眠模式 0x86+结束符
#define UART_SleepOpen      0X87    //设备自动唤醒 0x87+结束符
#define UART_Startup        0X88    //系统启动成功
#define UART_SD             0X89    //开始SD卡升级
#define UART_End            0Xff    //结束符
#define _BufSize            64      //设置64位数据.

/****************************************************************************
 * 名称： Uart类
 * 功能： 函数集合
 * 参数：
 ****************************************************************************/
class Uart
{
public:
    unsigned char WaitCommand(char needwait);//接收串口数据
    unsigned char FindCommand();//按接收到的数据分支执行函数
    

    unsigned char cmd_screen_id;        //页面ID;
    unsigned char cmd_control_id;       //控件ID;
    unsigned char cmd_button_v;         //控件状态.0为弹起,1为按下
    unsigned char _RecvBuff[_BufSize];  //定义接收命令64位数组
    unsigned char _SendBuff[_BufSize];  //定义接收数据64位数组
    unsigned char _RecvCount;           //接收命令长度
    unsigned char _SendCount;           //接收数据长度.
    unsigned char Return_val;           //测试返回值
    unsigned char GetButton_Return_val;           //按钮类型状态返回值
    unsigned char GetContro_Return_val;           //数值数据返回值
    boolean EndButton=false,StartButton=false;
    boolean PauseButton=false,ContinueButton=false;
    /****************************************************************************
     * 名称：ButtonState()
     * 功能：检测按钮状态
     * 参数：EndButton,StartButtone ,PauseButton,ContinueButton
     ****************************************************************************/
    void ButtonState();
    /****************************************************************************
     * 名称：GetControlV
     * 功能：取数值数据;整个函数返回取值.get n().val
     * 参数：Contro;
     ****************************************************************************/
    unsigned char GetControlV(unsigned char Contro);
    /****************************************************************************
     * 名称：GetControlV
     * 功能：取按钮状态数据;整个函数返回取值.get bt().val
     * 参数：Contro;
     ****************************************************************************/
    unsigned char GetButtonV(unsigned char Contro);
    /****************************************************************************
     * 名称：ErrorCommand()
     * 功能：无效指令返回;
     * 参数：
     ****************************************************************************/
    unsigned char ErrorCommand();
    /****************************************************************************
     * 名称：UartTouch()
     * 功能：触摸热区事件返回函数
     * 参数：
     ****************************************************************************/
    unsigned char UartTouch();
    /****************************************************************************
     * 名称： UartTouchdata()
     * 功能： 触摸坐标数据返回函数
     * 参数：
     ****************************************************************************/
    void UartTouchdata();
    /****************************************************************************
     * 名称： 睡眠模式触摸事件函数
     * 功能： 函数集合
     * 参数：
     ****************************************************************************/
    void UartSleep();
    /****************************************************************************
     * 名称： UartAscii()
     * 功能： 字符串变量数据返回函数
     * 参数：
     ****************************************************************************/
    void UartAscii();
    /****************************************************************************
     * 名称： UartDatavar()
     * 功能： 数值变量数据返回函数
     * 参数：
     ****************************************************************************/
    void UartDatavar();
    /****************************************************************************
     * 名称： UartSleepmode()
     * 功能： 设备自动进入睡眠模式函数
     * 参数：
     ****************************************************************************/
    void UartSleepmode();
    /****************************************************************************
     * 名称： UartSleepOpen()
     * 功能： 设备自动唤醒函数
     * 参数：
     ****************************************************************************/
    void UartSleepOpen();
    /****************************************************************************
     * 名称： UartStartup()
     * 功能： 系统启动成功函数
     * 参数：
     ****************************************************************************/
    void UartStartup();
    /****************************************************************************
     * 名称： UartSD()
     * 功能： 开始SD卡升级函数
     * 参数：
     ****************************************************************************/
    void UartSD();
    /****************************************************************************
     * 名称： UartEnd();
     * 功能：  结束符函数
     * 参数： 无
     ****************************************************************************/
    void UartEnd();
    /****************************************************************************
     * 名称 SendDim()
     * 功能：设置屏幕亮度0-100
     * 参数：i(0-100)
     ****************************************************************************/
    void SendDim(int i);
    
};
#endif // COLOR_H

