//
// Uart.cpp
// C++ code
// ----------------------------------
// Developed with embedXcode+
// http://embedXcode.weebly.com
//
// Project 		MY_berr
//
// Created by 	刘钊, 15/10/29 下午3:27
//
// Copyright 	(c) 刘钊, 2015年
// Licence		<#license#>
//
// See 			Uart.h and ReadMe.txt for references
//


#include "Uart.h"
#include "Arduino.h"

//串口接收数据
unsigned char Uart::WaitCommand(char needwait)
{
    int ttt = 0;
    if (needwait)
    {
        while (Serial1.available() == 0)
        {
            
            delay(1);
            ttt++;
            if (ttt > 100)  //可改
            {
                return 0;   //超时退出
            }
        }
    }
    while (Serial1.available()) //监测串口是否有数据
    {
        _RecvBuff[_RecvCount++] = Serial1.read(); //串口读到得字节写入到SS
        ttt=0;
        while (Serial1.available() == 0)
        {
            delayMicroseconds(100);
            ttt++;
            if (ttt > 20) //可改
            break;
        }
        //溢出处理
        if (_RecvCount >= _BufSize) //如果读入计数器大于等于64.
        {
            _RecvCount--; //计数器自减.
        }
    }
    if (_RecvCount>3)
    {
       
        if ((_RecvBuff[_RecvCount-3]==UART_End)&&
            (_RecvBuff[_RecvCount-2]==UART_End)&&
            (_RecvBuff[_RecvCount-1]==UART_End))
        {
              _SendCount=_RecvCount;
            _RecvCount=0;
            return FindCommand();
        }
        else
        {
            _RecvCount=0;
            return 0; //无有效命令
        }
    }
    
    return 0; //无有效命令
}
unsigned char  Uart::FindCommand()
{
    unsigned char rv = 0;
    switch (_RecvBuff[0])
    {
        case UART_touch:    UartTouch();  rv = UART_touch;  break; //触摸热区事件返回
        case UART_Touchdata: UartTouchdata(); rv = UART_Touchdata; break; //触摸坐标数据返回
        case UART_Sleep:    UartSleep(); rv = UART_Sleep;   break; //眠模式触摸事件
        case UART_Ascii:    UartAscii(); rv = UART_Ascii;   break; //字符串变量数据返回
        case UART_Datavar:  UartDatavar(); rv = UART_Datavar; break; //数值变量数据返回
        case UART_Sleepmode: UartSleepmode(); rv = UART_Sleepmode; break; //设备自动进入睡眠模式
        case UART_SleepOpen: UartSleepOpen(); rv = UART_SleepOpen; break; //设备自动唤醒
        case UART_Startup:  UartStartup(); rv = UART_Startup;  break; //系统启动成功
        case UART_SD:       UartSD();  rv = UART_SD;     break; //开始SD卡升级
        case UART_Ok:       UartOk(); rv = UART_Ok;     break; //指令成功执行
        default:
            break;
    }
    Serial.print("FC:");
    Serial.print (rv);
    Serial.print("  =");
    for (int i = 0; i < _SendCount; ++i)
    {
        Serial.print(_RecvBuff[i]);
        Serial.print(" ");
    }
    Serial.println("");
    return rv;
}
/*unsigned char  Uart::FindCommand()
{
    unsigned char rv = 0;
    switch (_RecvBuff[0])
    {
        case UART_touch:    UartTouch();        rv = UART_touch;    break; //触摸热区事件返回
        case UART_Touchdata: UartTouchdata();   rv = UART_Touchdata;break; //触摸坐标数据返回
        case UART_Sleep:    UartSleep();        rv = UART_Sleep;    break; //睡眠模式触摸事件
        case UART_Ascii:    UartAscii();        rv = UART_Ascii;    break; //字符串变量数据返回
        case UART_Datavar:  UartDatavar();      rv = UART_Datavar;  break; //数值变量数据返回
        case UART_Sleepmode: UartSleepmode();   rv = UART_Sleepmode;break; //设备自动进入睡眠模式
        case UART_SleepOpen: UartSleepOpen();   rv = UART_SleepOpen;break; //设备自动唤醒
        case UART_Startup:  UartStartup();      rv = UART_Startup;  break; //系统启动成功
        case UART_SD:       UartSD();           rv = UART_SD;       break; //开始SD卡升级
        case UART_Ok:       UartOk();           rv = UART_Ok;       break; //指令成功执行
        default:
            break;
    }
    return rv;
}*/
//指令成功执行;
void Uart::UartOk()
{
    Serial.println("Command_send_ok");
}
//取数值数据
unsigned char Uart::GetData(unsigned char data)
{
    String Get="get n",Val=".val",GetValL;
    GetValL=Get+data+Val;
     UartEnd();
    Serial1.print(GetValL);
    UartEnd();
}
void Uart::UartDatavar()
{
    unsigned char data1 ;
    Serial.println("cs2");
    Return_val = 0;
    for (int i = 0; i < _SendCount; ++i)
    {
        Serial.print(_RecvBuff[i]);
        Serial.print(" ");
    }
    Serial.println("");
    
    if (_SendCount >= 8)
    {
     Return_val = _RecvBuff[1];
    }
    
    
}

//取按钮当前状态
unsigned char Uart::GetButtonV(unsigned char data)
{
    String Get="get bt",Val=".val",GetValL;
    GetValL=Get+data+Val;
    Serial1.print(GetValL);
    UartEnd();
    delay(200);
}

//触摸热区事件返回函数
unsigned char Uart::UartTouch()
{
    Serial.println("UARTOUCH");
    unsigned char returnv=0;
    cmd_screen_id= _RecvBuff[1];
    returnv =cmd_screen_id;
    cmd_control_id=_RecvBuff[2];
    returnv =cmd_control_id;
    cmd_button_v=_RecvBuff[3];
    returnv =cmd_button_v;
    return returnv;
    
}

//触摸坐标数据返回函数
void Uart::UartTouchdata()
{
    
}
//睡眠模式触摸事件函数
void Uart::UartSleep()
{
    
}
//字符串变量数据返回函数
void Uart::UartAscii()
{
    
}
//设备自动进入睡眠模式函数
void Uart::UartSleepmode()
{
    
}
//设备自动唤醒函数
void Uart::UartSleepOpen()
{
    
}
//系统启动成功函数

void Uart::UartStartup()
{
    
}
//开始SD卡升级函数

void Uart::UartSD()
{
    
}
//结束符函数
void Uart::UartEnd()
{
    Serial1.write(UART_End);
    Serial1.write(UART_End);
    Serial1.write(UART_End);
}
