//
// File			Uart.h
// Header
//
// Details		<#details#>
//
// Project		 MY_berr
// Developed with [embedXcode](http://embedXcode.weebly.com)
//
// Author		刘钊
// 				刘钊
//
// Date			15/10/29 下午3:28
// Version		<#version#>
//
// Copyright	© 刘钊, 2015年
// Licence    <#license#>
//
// See			ReadMe.txt for references
//
#ifndef Uart_H  //预编译指令，防止重复定义类
#define Uart_H
#include "Arduino.h"

#define  UART_touch         0X65  //触摸热区事件返回
#define  UART_ID            0X66  //当前页面的ID号返回
#define  UART_Touchdata     0X67  //触摸坐标数据返回
#define  UART_Sleep         0X68  //睡眠模式触摸事件
#define  UART_Ascii         0X70  //字符串变量数据返回
#define  UART_Datavar       0X71  //数值变量数据返回
#define  UART_Sleepmode     0x86  //设备自动进入睡眠模式 0x86+结束符
#define  UART_SleepOpen     0X87  //设备自动唤醒 0x87+结束符
#define  UART_Startup       0X88  //系统启动成功
#define  UART_SD            0X89  //开始SD卡升级
#define  UART_Ok            0X01  //指令成功执行
#define  UART_End           0Xff  //结束符
#define _BufSize            64    //设置64位数据.

class Uart
{
public:
    unsigned char WaitCommand(char needwait);//接收串口数据
    unsigned char FindCommand();//按接收到的数据分支执行函数
    
    unsigned char GetData(unsigned char data); //get (n).val
    unsigned char GetButtonV(unsigned char data); //get (bt).val
    unsigned char UartTouch();  //触摸热区事件返回函数
    
    void UartTouchdata();       //触摸坐标数据返回函数
    void UartSleep();           //睡眠模式触摸事件函数
    void UartAscii();           //字符串变量数据返回函数
    void UartDatavar();         //数值变量数据返回函数
    void UartSleepmode();       //设备自动进入睡眠模式函数
    void UartSleepOpen();       //设备自动唤醒函数
    void UartStartup();         //系统启动成功函数
    void UartSD();              //开始SD卡升级函数
    void UartEnd();             //结束符函数
    void UartOk();              //指令成功执行

    unsigned char ByeteData,ThData,Thtime,ZfData,Zftime;
    unsigned char cmd_screen_id; //页面ID;
    unsigned char cmd_control_id;//控件ID;
    unsigned char cmd_button_v;  //控件状态.0为弹起,1为按下
    unsigned char _RecvBuff[_BufSize];  //定义接收命令64位数组
    unsigned char _SendBuff[_BufSize];  //定义接收数据64位数组
    unsigned char _RecvCount;           //接收命令长度
    unsigned char _SendCount;           //接收数据长度.
    unsigned char Return_val;   //返回值
};
#endif // COLOR_H

